/**
 * FlAIR - Flickr Application for Adobe AIR
 * APP.JS
 * Initializes application and handles other general UI tasks
 */

var app = {
	fullscreen:false,
	user:null,
	currentPhotos:null,
	activeDialog:null,
	slideshowTimer:null,
	thumbnails:[],
	error:function(msg)
	{
		var err = new Dialog('ui-error');
		msg = msg || "Something has gone wrong and this application doesn't know what to do. You'll need restart the application. Sorry.";
		$E('.message', err.element).innerText = msg;
		err.show();
	},
	init:function(){
		// initialize UI
		var topnavPanel = new Fx.Slide('topnav',{duration:300});
		topnavPanel.slideOut();
		
		$('user').setStyle('display','none');
		/*
		window.addEventListener(	window.runtime.flash.events.NativeDragEvent.NATIVE_DRAG_ENTER,function(){console.log('dragenter')});
        window.addEventListener(	window.runtime.flash.events.NativeDragEvent.NATIVE_DRAG_DROP,function(){console.log('dragdrop')});
        window.addEventListener(	window.runtime.flash.events.NativeDragEvent.NATIVE_DRAG_EXIT,function(){console.log('dragexit')});
		*/
		// set up event handlers
		document.onmousemove = function(e){
			/*
			if(e.clientY < 40 && e.target.tagName != 'BUTTON') { topnavPanel.slideIn() }
			if(e.clientY > topnavPanel.element.offsetHeight + 20) { topnavPanel.slideOut() }
			*/
			if((e.clientY < 40 || e.clientX < 40) 
				&& parseInt($('contacts').getStyle('left')) < -199 
				&& e.target.tagName != 'BUTTON') { 
				topnavPanel.slideIn();
				$('contacts').effects({duration:500}).start({			
					'left':[-200, 0],
					'top':[120, 60]
					})			
			};
			if((e.clientY > 80 && e.clientX > 220) && parseInt($('contacts').getStyle('left')) > -1) { 
				topnavPanel.slideOut()
				$('contacts').effect('left', {duration:500}).start(0, -200);
	
			}
			
		};
		
		document.onclick=function(evt)
		{
			if(!evt && !evt.target) return;
			var t = evt.target;
			var clickednav = false;
			while(t && t.nodeType == 1)
			{
				// if it's an external link
				if(t.tagName.toLowerCase() == 'a' && /^https?\:\/\//.test(t.href))
				{
					air.navigateToURL(new air.URLRequest(t.href));
					return false;
				}
				t = t.parentNode;
			}

		}
		
		
		$('btnFullScreen').addEvent('click', app.fullscreenToggle);
		$('btnGotoFlickr').addEvent('click', function(){
				air.navigateToURL(new air.URLRequest( this.getAttribute('href') ));	
			});
		$('slideshow').addEvent('click', function(){ 
			var ss = new Slideshow(); 
			ss.start();
			});
			
		$('logout').addEvent('click', (function(){
			this.user.logout();
			return false;
		}).bind(this))



		// initialize the base user
		this.user = new ApplicationUser();
		this.user.login();
	},
	fullscreenToggle:function(){
		var ds = runtime.flash.display.StageDisplayState;
		window.nativeWindow.stage.displayState = 
			(window.nativeWindow.stage.displayState == ds.FULL_SCREEN)
			? window.nativeWindow.stage.displayState = ds.NORMAL
			: window.nativeWindow.stage.displayState = ds.FULL_SCREEN;
	},
	busy:function(status)
	{
		$('loader').setStyle('display', status ? 'block':'none');
	},
	getEncrypted:function(key)
	{
		var ret = null;
		var storedValue = air.EncryptedLocalStore.getItem(key);
		if(storedValue) ret = storedValue.readUTFBytes(storedValue.length);
        return ret;
	},
	setEncrypted:function(key, value)
	{
        var bytes = new air.ByteArray();
        bytes.writeUTFBytes(value);
        air.EncryptedLocalStore.setItem(key, bytes);
	},
	viewSlideshow:function()
	{
		
	}
}

window.onload = app.init.bind(app);
