/**
 * FlAIR - Flickr Application for Adobe AIR
 * APPUSER.JS - Application User Class
 * instantiates application user and handles authentication
 */

var ApplicationUser = new Class({
	dialog:null,
	flickr:null,
	nsid:null,
	name:null,
	pass:null,
	initialize:function(){
		this.dialog = new Dialog('ui-login',{screenOpacity:1, close:false});
		$E('.btnLogin', this.dialog.element).onclick = this.processLogin.bindAsEventListener(this);
	},
	login:function(){
		this.dialog.show();
	},
	logout:function(){
		$('btnGotoFlickr').setAttribute('href', 'http://flickr.com/');
		$E('#user .avatar img').src = 'img/avatar.jpg';
		$('user').setStyle('display','none');
		$('thumbnails').setHTML('');
		this.dialog.show();
	},
	processLogin:function(e)
	{
		this.name = $('username').getValue();
		this.flickr = new Flickr( this );
		this.dialog.hide();
	},
	loginAccepted:function(o)
	{
		var userpane = $('user');
		userpane.setStyle('display','block');
		$E('.name', userpane.element).innerHTML = o.fullname + ( o.fullname != o.username ? ' (' + o.username + ')': '');
		this.name = o.username;
		this.nsid = o.nsid;
		
		var bg = app.getEncrypted('background' + this.name)
		if(bg) document.body.style.background = '#0D0D0D url(' + bg + ') no-repeat 50% 50%';
		
		
		
		// now that I'm logged in, grab some additional user information
		this.flickr.api('flickr.people.getInfo', {
			params:{user_id:this.nsid},
			success:this.processUserInfo.bind(this)
			})
		
		this.flickr.loadUser(this.nsid, this.name);
		$('myphotos').addEvent('click', (function(){
			this.flickr.loadUser(this.nsid,this.name)
		}).bind(this));
		
		var self = this.flickr;
		// grab photosets
		this.flickr.api('flickr.contacts.getList',{
			success:function(xml){
				$('contacts').innerHTML = '';
				var c = xml.getElementsByTagName('contact');
				
				function contactHandler(nsid, name)
				{
					return function(){
						self.loadUser(nsid,name);
					}
				}
				
				for(var i=0;i < c.length;i++)
				{
					var name = c[i].getAttribute('realname') || c[i].getAttribute('username');
					var div = document.createElement('div');
					div.className = 'contact';
					div.setAttribute('nsid', c[i].getAttribute('nsid'));
					div.innerHTML = '<div class="avatar"><img src="' + 'http://farm' + c[i].getAttribute('iconfarm') + '.static.flickr.com/' + c[i].getAttribute('iconserver') + '/buddyicons/' +  c[i].getAttribute('nsid') + '.jpg' +'"></div>' +
									'<div class="name">'+name+'<br>('+c[i].getAttribute('username')+')</div></div>';
					div.onclick = contactHandler(c[i].getAttribute('nsid'), name);
					$('contacts').appendChild(div);
				}
			}
			})
	},
	loginDenied:function()
	{
		$('user').setStyle('display','none');
		this.login();
	},
	processUserInfo:function(xml)
	{
		var person = xml.getElementsByTagName('person')[0];
		var iconfarm = person.getAttribute('iconfarm');
		var iconserver = person.getAttribute('iconserver');
		var nsid = person.getAttribute('nsid');

		if(iconfarm && iconserver && nsid)
		{
			$E('#user .avatar img').src = 'http://farm' + iconfarm + '.static.flickr.com/' + iconserver + '/buddyicons/' + nsid + '.jpg';
		}
		
		// 
		$('btnGotoFlickr').setAttribute('href', person.getElementsByTagName('photosurl')[0].textContent);

	}
})