/**
 * FlAIR - Flickr Application for Adobe AIR
 * DIALOG.JS - DIALOG CLASS
 * handles dialog display
 */

var Dialog = new Class({
	// fx object reference
	initialize:function(elId, options){
		this._id = elId;
		this._options = {
			hide:true,
			screenOpacity:0.6,
			close:true,
			onClose:function(){}
		};
		$extend(this._options, options);
		this.ui = $(this._id).effect('opacity', {duration:500, transition: Fx.Transitions.Sine.easeInOut});

		var screen = new Element('div',{ 'class':'screen' });
		document.getElementsByTagName('body')[0].appendChild(screen);

		if(this._options.close) {
			screen.onclick = (function(){ 
				this.hide(); 
				this._options.onClose();
			}).bind(this);	
		}
		this.screen = screen.effect('opacity', {duration:400, transition: Fx.Transitions.Sine.easeInOut})
		if(this._options.hide) {
			this.ui.hide();		
			this.screen.hide();	
		}
	},
	resize:function(options)
	{
		var el = $(this._id);
		var fx = el.effects({duration:1000, transition:Fx.Transitions.Sine.easeInOut})
		var fxOptions = {};
		if(options.height) 
		{
			fxOptions.height = [fx.element.offsetHeight, options.height];	
			fxOptions.top  = [parseInt(el.getStyle('top')), Math.ceil(Math.max(10,nativeWindow.height - options.height)/2)];
		}
		if(options.width)
		{
			fxOptions.width = [fx.element.offsetWidth, options.width];
			fxOptions["margin-left"]  = [parseInt(el.getStyle('margin-left')), (options.width / 2) * -1];
		}
		if(options.onComplete)
		{
			fxOptions.onComplete = options.onComplete;
		}
		fx.start(fxOptions);
	},
	show:function(){
		this.screen.start(0,this._options.screenOpacity);
		this.ui.start(0, 1);
	},
	hide:function(){
		this.screen.start(this._options.screenOpacity,0);
		this.ui.start(1,0);
	}
});

