/**
 * FlAIR - Flickr Application for Adobe AIR
 * FLICKR.JS - Flickr Class
 * Provides all access to the flickr
 */

var Flickr = new Class({
	apikey:'dc51a7dd4a5e079da721cb0316c7e65b',
	sharedKey:'05880b6fbec112f4',
	url:'http://api.flickr.com/services/rest/',
	frob:null,
	auth_token:null,
	user:null,
	initialize:function( user )
	{
		this.user = user;
		var token = app.getEncrypted('token' + user.name);
		if(token)
		{
			this.auth_token = token;
			this.checkToken();
		}else{
			this.api('flickr.auth.getFrob', { success:this.setFrob.bind(this) });
		}
	},
	setFrob:function(xml)
	{
		this.frob = xml.getElementsByTagName('frob')[0].textContent;
		
		var dialog = new Dialog('ui-authorize');
		var el = $E('.btnAuthComplete', dialog.element);
		el.onclick = (function()
		{
			this.api('flickr.auth.getToken', {params:{frob:this.frob}, success:this.setToken.bind(this)})
			dialog.hide();
		}).bind(this);
		el.style.display = 'none';
		$E('.btnAuth', dialog.element).onclick = doAuth.bind(this);
		$E('.btnCancel', dialog.element).onclick = (function(){
				dialog.hide();
				this.user.login();
		}).bind(this);
		
		dialog.show();
		
		function doAuth(){
			var params = {
				api_key:this.apikey,
				frob:this.frob,
				perms:'delete',
				api_sig: hex_md5(this.sharedKey + 'api_key' + this.apikey + 'frob' + this.frob + 'permsdelete')
			};
			air.navigateToURL(new air.URLRequest('http://flickr.com/services/auth/?' + Object.toQueryString(params)));	
			$E('.btnAuth', dialog.element).style.display = 'none';
			el.style.display = '';
		}
	},
	setToken:function(xml)
	{
		this.auth_token = xml.getElementsByTagName('token')[0].textContent;
		app.setEncrypted('token' + this.user.name, this.auth_token);
		this.user.loginAccepted({
			nsid:		xml.getElementsByTagName('user')[0].getAttribute('nsid'),
			username:	xml.getElementsByTagName('user')[0].getAttribute('username'),
			fullname:	xml.getElementsByTagName('user')[0].getAttribute('fullname'),
			perms:		xml.getElementsByTagName('perms')[0].textContent
		});
	},
	checkToken:function(token)
	{
		this.api('flickr.auth.checkToken', { 
			success:this.setToken.bind(this),
			failure:this.tokenFailed.bind(this)
			});
	},
	tokenFailed:function(msg, code)
	{
		this.frob = null;
		this.auth_token = null;
		this.api('flickr.auth.getFrob', { success:this.setFrob.bind(this) });
	},
	loadUser:function(nsid, name)
	{
		// grab thumbnails
		this.api('flickr.people.getPublicPhotos',{
			params:{
				user_id:nsid,
				extras:'original_format'
			},
			success:function(xml){
				$('thumbnails').innerHTML = '';
				$('title').innerHTML = name + "'s Photos";
				$('title').setStyle('visibility','visible');
				var p = xml.getElementsByTagName('photo');
				app.thumbnails = [];
				for(var i=0;i < p.length;i++)
				{
					app.thumbnails[app.thumbnails.length] = new FlickrImage( p[i] );
				}
				
			}
			})
	},
	// handles all Flickr API calls
	api:function(method, options)
	{
		var params = {
			method:method,
			api_key:this.apikey
		}
		$extend(params, options.params)
		
		if(this.auth_token){
			params.auth_token = this.auth_token;
		}else if(this.frob){
			params.frob = this.frob;
		}
		
		var newparams = []
		for(var item in params)
		{
			newparams[newparams.length] = {key: item, value:params[item]};
		}
		newparams.sort(function(a,b){
			return ((a.key < b.key) ? -1 : ((a.key > b.key) ? 1 : 0));
		})
		
		var str = '';
		for(var i=0;i<newparams.length;i++)
		{
			str += newparams[i].key += newparams[i].value;
		}

		var sig = hex_md5(this.sharedKey + str);
		params.api_sig = sig;
		
		app.busy(true);
		var ajax = new Ajax(this.url, {method: 'get', data:params, onComplete:complete, onSuccess:success, onFailure:failure}).request();
		
		function success(){
			
			var xml = ajax.response.xml;
			var err = xml.getElementsByTagName('err');
			if(err.length == 0){
				if(options.success) options.success(xml);	
			}else{
				if(options.failure) {
					options.failure(err[0].getAttribute('msg'), err[0].getAttribute('code'));
				}else{
					failure();
				}
			}

		}
		function failure(){
			app.error();
		}
		function complete(){
			app.busy(false);
		}

		
	}
})