/**
 * FlAIR - Flickr Application for Adobe AIR
 * SLIDESHOW.JS - SLIDESHOW CLASS
 * handles the slideshow, starting, stopping, loading images.
 */

var Slideshow = new Class({
	// fx object reference
	initialize:function(){
		this.dialog = new Dialog('ui-slideshow',{screenOpacity:1, onClose:this.stop.bind(this)});
		this.dialog.ui.element.style.visibility = 'hidden';
		this.current = 0;
		this.loaded = [];
	},
	start:function(){
		this.timer = setInterval(this.next.bind(this), 3000);
		this.dialog.show();
		this.loadImage(0);
	},
	next:function(){
		this.hideImage(this.current);
		this.current = (this.current == app.thumbnails.length - 1) ?  0 : this.current + 1;
		this.loadImage(this.current);
	},
	previous:function(){
		this.hideImage(this.current);
		this.current = (this.current == 0) ? app.thumbnails.length : this.current - 1;
		this.loadImage(this.current);
	},
	stop:function(){
		clearInterval(this.timer);
		this.dialog.hide();		
		this.hideImage(this.current);
	},
	loadImage:function(index)
	{
		var el = $('slide' + index);
		if(!el)
		{
			el = new Element('div', {'id':'slide' + index, 'class':'slide'});
		}
		el.setStyle('opacity',0);

		var url = app.thumbnails[this.current].buildURL('');
		var img = new Image();
		img.src = url;
		img.onload = (function()
		{
			el.setStyle('top', Math.max(0, Math.ceil(nativeWindow.height/2 - img.height/2)-20));
			var fx = el.effects({duration:500, transition:Fx.Transitions.Sine.easeInOut})
			var left = Math.ceil(nativeWindow.width/2 - (img.width)/2);
			fx.start({
				opacity: [0,1],
				left:[left + 150, left]
			})
			this.loaded[0] = true;
		}).bind(this);
		
		el.appendChild(img);
		document.body.appendChild(el);
	},
	hideImage:function(index)
	{
		var el = $('slide' + index);
		if(el)
		{
			var fx = el.effects({duration:500, transition:Fx.Transitions.Sine.easeInOut, onComplete:function(){ document.body.removeChild(el) }})
			var left = parseInt(el.getStyle('left'));
			fx.start({
				opacity: [1,0],
				left:[left, left - 150]
			})
		}
	}
});

